unit MagShowLog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TShowLog = class(TForm)
    OpenDialog1: TOpenDialog;
    procedure OpenLogFile(defDirectory:string;Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ShowLog: TShowLog;

implementation

uses magWebHelp;

{$R *.DFM}

procedure TShowLog.OpenLogFile(defDirectory:string;Sender: TObject);
var
  OpenDialog: TOpenDialog;
begin
  OpenDialog := TOpenDialog.Create(Self);
  with OpenDialog do begin
   if defDirectory <> '' then InitialDir := defDirectory
   else InitialDir := ExtractFilePath(Application.ExeName)+'log\';
    //DefaultExt := '*.*';
    Filter := 'Log files (Any files (*.*)|*.*|*.log)|*.log|'+
              'HTML files (*.HTML|*.HTML|'+
              'Certed files (Certed*.log)|Certed*.log|'+
              'Scan files (Scan*.log)|Scan*.log|'+
              'ScanError files (ScanError*.log)|ScanError*.log|'+
              'Text files (*.txt)|*.txt|Any files (*.*)|*.*';
    FilterIndex := 0; { start the dialog showing all files }
    Options := [ofFileMustExist,ofPathMustExist,ofEnableSizing];
    if NOT Execute then exit
    else begin
      if pos('HTML',UpperCase(FileName)) <> 0 then begin
        Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
        frmMagBPHelp.WB.Navigate(FileName);
        frmMagBPHelp.Caption := 'BP Log file : '+ FileName;
        end
      else WinExec(pchar('NOTEPAD.exe '+FileName),SW_SHOW);
      end;
    end; //with OpenDialog
end;
end.
