unit MagImportQueue1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, ComCtrls, MFunStr, ExtCtrls;

type
  TfrmMagImportQueue = class(TForm)
    grpTrackingID: TGroupBox;
    gbImportQueueLookup: TGroupBox;
    edImportQueueLookup: TEdit;
    edTrackingID: TEdit;
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    gbWindowsSession: TGroupBox;
    lvWindowsSession: TListView;
    TabSheet2: TTabSheet;
    gbAcquisitionSession: TGroupBox;
    lvAcquisitionSession: TListView;
    TabSheet3: TTabSheet;
    gbImportQueue: TGroupBox;
    lvImportQueue: TListView;
    stImagefileName: TStaticText;
    stImagefileNumber: TStaticText;
    stImageien: TStaticText;
    procedure edTrackingIDKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edTrackingIDMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure edImportQueueLookupMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure lvColumnClick(Sender: TObject;Column: TListColumn);
    procedure lvCompare(Sender: TObject; Item1,Item2: TListItem; Data: Integer; var Compare: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMagImportQueue: TfrmMagImportQueue;

implementation

uses magbtm1,UnitDM,MagSiteParameters,MAGNetLoc2;
{$R *.dfm}


procedure TfrmMagImportQueue.edTrackingIDKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var i,k,cnt: integer;
  IQIen,ASIen,WSIen,ImageIEN: string;
  Labels: TStringList;
  NewColumn: TListColumn;
  ListItem: TListItem;
  Temp : string;
begin
 if (Key <> VK_RETURN) then exit;
  lvImportQueue.Clear;
  if lvImportQueue.Parent.ClassName = 'TGroupBox' then (lvImportQueue.Parent as TGroupBox).Caption :=
     piece((lvImportQueue.Parent as TGroupBox).Caption,'-',1)+'-';
  lvAcquisitionSession.Clear;
  if lvAcquisitionSession.Parent.ClassName = 'TGroupBox' then (lvAcquisitionSession.Parent as TGroupBox).Caption :=
     piece((lvAcquisitionSession.Parent as TGroupBox).Caption,'-',1)+'-';
  lvWindowsSession.Clear;
  if lvWindowsSession.Parent.ClassName = 'TGroupBox' then (lvWindowsSession.Parent as TGroupBox).Caption :=
     piece((lvWindowsSession.Parent as TGroupBox).Caption,'-',1)+'-';
  WSIen := '0';
  ASIen := '0';
  IQIen := '0';
  ImageIEN := '0';
  stImagefileNumber.Caption := '';
  stImageIEN.Caption := '';
  stImagefileName.Caption := '';
  if (sender as TEdit).Name = 'edImportQueueLookup' then begin
    edTrackingID.Text := '';
    edImportQueueLookup.Text := trim(edImportQueueLookup.Text);
    if length(edImportQueueLookup.Text) < 1 then exit;
    ASIen := dmMain.GetVariable('$S($D(^MAG(2006.041,"B","'+edImportQueueLookup.Text+'"))'+
      ':$O(^MAG(2006.041,"B","'+edImportQueueLookup.Text+'","")),1:0)');
    if ASIen <> '0' then begin
      edImportQueueLookup.Text := dmMain.GetFieldValue('2006.041','.01',ASIen+',','E',true);
      edTrackingID.Text := dmMain.GetFieldValue('2006.041','.02',ASIen+',','E',true);
      if length(edTrackingID.Text) > 5 then
        WSIen := dmMain.GetVariable('$S($D(^MAG(2006.82,"E","'+edTrackingID.Text+'"))'+
         ':$O(^MAG(2006.82,"E","'+edTrackingID.Text+'","'+WSIen+'")),1:0)');
      IQIen := dmMain.GetVariable('$S($D(^MAG(2006.034,"B","'+edImportQueueLookup.Text+'"))'+
        ':$O(^MAG(2006.034,"B","'+edImportQueueLookup.Text+'","")),1:0)');
      end;  // if ASIen <> '0'
    end; // if (sender as TEdit).Name = 'edImportQueueLookup'
  if (sender as TEdit).Name = 'edTrackingID' then begin
    edImportQueueLookup.Text := '';
    edTrackingID.Text := trim(edTrackingID.Text);
    if length(edTrackingID.Text) < 5 then exit;
    ASIen := dmMain.GetVariable('$S($D(^MAG(2006.041,"C","'+edTrackingID.Text+'"))'+
      ':$O(^MAG(2006.041,"C","'+edTrackingID.Text+'","0")),1:0)');
    if ASIen <> '0' then begin
      IQIen := dmMain.GetFieldValue('2006.041','.01',ASIen+',','I',true);
      edImportQueueLookup.Text := IQIEN;
      end;  // if ASIen <> '0'
    WSIen := dmMain.GetVariable('$S($D(^MAG(2006.82,"E","'+edTrackingID.Text+'"))'+
       ':$O(^MAG(2006.82,"E","'+edTrackingID.Text+'","'+WSIen+'")),1:0)');
    end;  // if (sender as TEdit).Name = 'edTrackingID'
  // Check and Display Image File relationship Tracking ID
   if length(edTrackingID.Text) > 5 then begin
     ImageIEN := dmMain.GetVariable('$S($D(^MAG(2005,"ATRKID","'+edTrackingID.Text+'"))'+
       ':$O(^MAG(2005,"ATRKID","'+edTrackingID.Text+'","'+ImageIen+'")),1:0)');
     if ImageIEN <> '0' then begin
       stImagefileNumber.Caption := 'Found in Image file: 2005';
       stImageIEN.Caption := 'Internal entry #:'+ ImageIEN;
       stImagefileName.Caption := 'Image file name: '+ dmMain.GetFieldValue('2005','1',ImageIen+',','E',true);
       end; // if ImageIEN <> '0'
     ImageIEN := dmMain.GetVariable('$S($D(^MAG(2005.1,"ATRKID","'+edTrackingID.Text+'"))'+
       ':$O(^MAG(2005.1,"ATRKID","'+edTrackingID.Text+'","'+ImageIen+'")),1:0)');
     if ImageIEN <> '0' then begin
       stImagefileNumber.Caption := 'Found in Image aRCHIVE file:2005.1';
       stImageIEN.Caption := 'Internal entry #:'+ ImageIEN;
       stImagefileName.Caption := 'Image file name: '+ dmMain.GetFieldValue('2005.1','1',ImageIen+',','E',true);
       end; // if ImageIEN <> '0'
     end; // if length(edTrackingID.Text) > 5
  // first display ACQUISITION SESSION FILE entries
  if ASIen <> '0' then begin
    dmMain.fmgAcquisitionSession.IENS := ASIen+',';
    frmSiteParameters.LVGUpdate(true,true,dmMain.fmgAcquisitionSession,lvAcquisitionSession);
    repeat
      ASIen := dmMain.GetVariable('$S($D(^MAG(2006.041,"C","'+edTrackingID.Text+'"))'+
        ':$O(^MAG(2006.041,"C","'+edTrackingID.Text+'","'+ASIen+'")),1:0)');
      if ASIen = '0' then break;
      dmMain.fmgAcquisitionSession.IENS := ASIen+',';
      frmSiteParameters.LVGUpdate(false,true,dmMain.fmgAcquisitionSession,lvAcquisitionSession);
    until ASIen='0';
    end; // if ien <> 0
  // next get Import Queue data
  lvImportQueue.Items.Clear;
  lvImportQueue.Columns.Clear;
  if lvImportQueue.Parent.ClassName = 'TGroupBox' then (lvImportQueue.Parent as TGroupBox).Caption :=
     piece((lvImportQueue.Parent as TGroupBox).Caption,'-',1)+'-';
  if IQIen <> '0' then begin
    lvImportQueue.Items.BeginUpdate;
    Labels := frmSiteParameters.GetLabels(dmMain.fmlImportQueue);
    for k := 0 to Labels.Count - 1 do begin
      NewColumn := lvImportQueue.Columns.Add;
      NewColumn.Caption := Labels[k];
      if magbtmf1.mnu508mode.Checked then
        if lvImportQueue.Parent.ClassName = 'TGroupBox' then
          (lvImportQueue.Parent as TGroupBox).Caption := (lvImportQueue.Parent as TGroupBox).Caption +
          ' ' + NewColumn.Caption;
      end;
    cnt := StrToInt(dmMain.GetVariable('$S($D(^MAG(2006.034,'+IQIen+',1,0))'+
          ':$P($G(^MAG(2006.034,'+IQIen+',1,0)),U,4),1:0)'));
    if cnt > 0 then
      for i := 1 to cnt do begin
        ListItem := lvImportQueue.Items.Add;
        ListItem.ImageIndex := 0;
        ListItem.Caption := dmMain.GetVariable('$S($D(^MAG(2006.034,'+IQIen+',1,'+IntToStr(i)+',0))'+
          ':$G(^MAG(2006.034,'+IQIen+',1,'+IntToStr(i)+',0)),1:0)');
        end;
    if lvImportQueue.Columns.Count > 0 then
      lvImportQueue.Columns[0].width := lvImportQueue.Width;
    lvImportQueue.Items.EndUpdate;
    end; // if IQIen <> '0'
  lvWindowsSession.Items.Clear;
  lvWindowsSession.Columns.Clear;
  if lvWindowsSession.Parent.ClassName = 'TGroupBox' then (lvWindowsSession.Parent as TGroupBox).Caption :=
     piece((lvWindowsSession.Parent as TGroupBox).Caption,'-',1)+'-';
  if WSIen <> '0' then begin
    lvWindowsSession.Items.BeginUpdate;
    //Labels := frmSiteParameters.GetLabels(dmMain.fmlSessionFileErrors);
    //for k := 0 to Labels.Count - 1 do begin
      NewColumn := lvWindowsSession.Columns.Add;
      NewColumn.Caption := 'Action / Errors '; //Labels[k];
      if magbtmf1.mnu508mode.Checked then
        if lvWindowsSession.Parent.ClassName = 'TGroupBox' then
          (lvWindowsSession.Parent as TGroupBox).Caption := (lvWindowsSession.Parent as TGroupBox).Caption +
          ' ' + 'Action / Errors '; //NewColumn.Caption;
      end; // for k := 0 to Labels.Count
    while WSIen <> '0' do begin
      cnt := StrToInt(dmMain.GetVariable('$S($D(^MAG(2006.82,'+WSIen+',"ACT",0))'+
              ':$P($G(^MAG(2006.82,'+WSIen+',"ACT",0)),U,4),1:0)'));
      if cnt > 0 then
        for i := 1 to cnt do begin
          ListItem := lvWindowsSession.Items.Add;
          ListItem.ImageIndex := 0;
          ListItem.Caption := 'ACTION: '+dmMain.GetVariable('$S($D(^MAG(2006.82,'+WSIen+',"ACT",'+IntToStr(i)+',0))'+
            ':$G(^MAG(2006.82,'+WSIen+',"ACT",'+IntToStr(i)+',0)),1:"")');
          temp := dmMain.GetVariable('$S($D(^MAG(2006.82,'+WSIen+',"ACT",'+IntToStr(i)+',1))'+
            ':$G(^MAG(2006.82,'+WSIen+',"ACT",'+IntToStr(i)+',1)),1:"")');
          if frmSiteParameters.IsStrANumber(temp) and (temp = '0') then next
          else ListItem.Caption := ListItem.Caption + temp;
          end;  // for i := 1 to cnt
      cnt := StrToInt(dmMain.GetVariable('$S($D(^MAG(2006.82,'+WSIen+',"ERR",0))'+
              ':$P($G(^MAG(2006.82,'+WSIen+',"ERR",0)),U,4),1:0)'));
      if cnt > 0 then
        for i := 1 to cnt do begin
          ListItem := lvWindowsSession.Items.Add;
          ListItem.ImageIndex := 0;
          ListItem.Caption := 'ERROR: '+dmMain.GetVariable('$S($D(^MAG(2006.82,'+WSIen+',"ERR",'+IntToStr(i)+',0))'+
            ':$G(^MAG(2006.82,'+WSIen+',"ERR",'+IntToStr(i)+',0)),1:0)');
          end;  // for i := 1 to cnt
      ListItem := lvWindowsSession.Items.Add;
      ListItem.ImageIndex := 0;
      ListItem.Caption := '';
      WSIen := dmMain.GetVariable('$S($D(^MAG(2006.82,"E","'+edTrackingID.Text+'"))'+
         ':$O(^MAG(2006.82,"E","'+edTrackingID.Text+'","'+WSIen+'")),1:0)');
      end; // while WSIen <> '0'
      if lvWindowsSession.Columns.Count > 0 then
        lvWindowsSession.Columns[0].width := lvWindowsSession.Width;
     lvWindowsSession.Items.EndUpdate;
end;

procedure TfrmMagImportQueue.edTrackingIDMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var key: word;
begin
  key := VK_RETURN;
 if ssLeft in Shift then
  if length(edTrackingId.Text) > 5 then edTrackingIDKeyDown(edTrackingID, key, shift);

end;

procedure TfrmMagImportQueue.edImportQueueLookupMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var key: word;
begin
  key := VK_RETURN;
 if ssLeft in Shift then
  if length(edImportQueueLookup.Text) > 5 then edTrackingIDKeyDown(edImportQueueLookup, key, shift);
end;

procedure TfrmMagImportQueue.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  frmMagImportQueue.ModalResult := mrCancel;
  Action := caFree;
end;

procedure TfrmMagImportQueue.FormActivate(Sender: TObject);
begin
  Application.NormalizeTopMosts;
  SetWindowPos(frmMagImportQueue.Handle, HWND_TOPMOST, 0,0,0,0,
    SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
end;
procedure TfrmMagImportQueue.lvColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  ColumnToSort := Column.Index;
  (Sender as TCustomListView).AlphaSort;
  if order = 'a' then order := 'd'
  else order := 'a';
end;
procedure TfrmMagImportQueue.lvCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
function CompAll(Input1,Input2:string):integer;
var
  I1,I2,C1,C2: Integer;
begin
    Val(Input1,I1,C1);
    Val(Input2,I2,C2);
  if ((c1 = 0) and (c2 = 0)) then begin
    if I1 > I2 then result := I1 - I2;
    if I1 < I2 then result := -(I2 - I1);
    if I1 = I2 then result := 0;
    end
  else result := CompareText(Input1,Input2);
  if order = 'd' then result := -result;
end;
var IX: integer;
begin
  if ColumnToSort = 0 then
    Compare := CompAll(Item1.Caption,Item2.Caption)
  else begin
   ix := ColumnToSort - 1;
   Compare := CompAll(Item1.SubItems[ix],Item2.SubItems[ix]);
  end;
end;

procedure TfrmMagImportQueue.FormCreate(Sender: TObject);
var i: integer;
begin
  order := 'd';
  for i := 0 to frmMagImportQueue.ComponentCount - 1 do begin
    if (frmMagImportQueue.Components[i] is TListView) then
      with frmMagImportQueue.Components[I] as TListView do begin
        OnColumnClick := lvColumnClick;
        OnCompare := lvCompare;
        RowSelect := true;
        end;
     end;

end;

procedure TfrmMagImportQueue.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (Key = 27) then frmMagImportQueue.Close;
end;

end.
