unit Maggut1;
 {ws18}
interface

uses StdCtrls, SysUtils, Controls,
 WinTypes, WinProcs, Messages, Classes, Graphics,
  Forms, Dialogs, Grids, Menus,ExtCtrls,trpcb;
type
userpreferences = record
   showabswindow : boolean;  { make it visible on patient selection}
   showmuse      : boolean;
   showimagegrid : boolean;  { make it visible on patient selection}
   showRadListWin  : boolean; { run the call to get rad exam list}
   TeleLkp : boolean ;
   absViewJBox : boolean;
   absRevOrder : boolean;
   {accessed : boolean;}
   getmain : boolean;
   getabs : boolean;
   getmuse : boolean;
   getfull : boolean;
   getgroup : boolean;
   getdoc : boolean;
   getreport : boolean;
   getimagegrid : boolean;
   getRadListWin  : boolean;

   mainstyle : byte;   { 0 - MDIChild, 1 - MDIForm   2 - Normal 3 - StayOnTop}
   mainpos : trect;       { top,  left , width, height  }
   absstyle :  byte;    { 0 - MDIChild, 1 - MDIForm   2 - Normal 3 - StayOnTop}
   abspos : trect;        { top,  left , width, height  }
   absmax : byte;
   abswidth : integer;
   absheight : integer;
   musestyle : byte;
   musepos : Trect;
   grpstyle : byte;
   grppos : trect;
   grpabsmax : byte;
   grpabswidth : integer;
   grpabsheight : integer;
   imagegridstyle : byte;
   imagegridpos : trect;
   RadListWinstyle : byte;
   RadListWinpos : trect;
   reportstyle : byte;
   reportpos : trect;
   reportfont : tfont;
   docstyle : byte;
   docpos : trect;
   docfitwidth : byte;
   docfitheight : byte;
   docbandingmode : byte;
   fullstyle : byte; { 0 - MDIChild      1 = seperate window }
   fullpos : trect;

end;

type
ConsultInfo = RECORD
   cRemHost :string[40];
  cPatdemog :string;
   cPatSSN  :string[9];
   cPatLiL4 :string[5];
   cPatName :string[30];
   cPatDOB  :string[20];
   cDUZ     :string[10];
end;

PMyList = ^AList;

   AList = record
        Mag0: String[10];
        AFile: String[130];
        FFile: String[130];
        ImgDes: String[70];
        ImgType: String[10];
        PtName: String[40];
        Date: String[20];
        Proc: String[30];
        AbsLocation: String[1];
      end;

type msgcode = set of char;

FUNCTION magStrToInt(str: string) :longint ;
FUNCTION magStripspaces(str: string) :string;
FUNCTION MAGLENGTH(STR,DEL:STRING):INTEGER ;
FUNCTION MAGPIECE(STR,DEL : STRING; PIECE : INTEGER ):STRING ;
FUNCTION USERHAVEKEY(FORM:TFORM; DUZ,KEY :STRING):STRING;
procedure showimagelist(stmp : Tlistbox; lstControl :TlistBox) ;
procedure MagLinkInit(var TempBroker:TRPCBroker);
procedure MagLinkSet(var TempBroker:TRPCBroker ; node :string);
procedure MagLinkGet(var TempBroker:TRPCBroker ; var dfn :string);
Procedure MagLogoff(var TempBroker:TRPCBroker);
implementation




FUNCTION MagPiece(str,del : String; Piece : Integer ):String ;
Var I,K : INTEGER ;
    s     : STRING ;
BEGIN
I:=Pos(del,str)  ;
IF (I=0) AND (PIECE =1) THEN BEGIN MAGPIECE := STR; EXIT ; END;
FOR K:=1 TO PIECE DO
    BEGIN
    I:=POS(DEL,STR) ;
    IF (I=0) THEN I:=LENGTH(STR)+1;
    S:=COPY(STR,1,I-1) ;
    STR:=COPY(STR,I+1,LENGTH(STR))  ;
    END;
MAGPIECE:=S ;
END;

FUNCTION MAGLENGTH(STR,DEL:STRING):INTEGER ;
VAR I,J: INTEGER ;
    ESTR : BOOLEAN ;
BEGIN
ESTR := FALSE    ;
I:=0;
WHILE NOT ESTR DO
      BEGIN
      I:=I+1;
      IF (POS(DEL,STR) = 0) THEN ESTR:= TRUE;
      J:=POS(DEL,STR); STR:=COPY(STR,J+1,LENGTH(STR)) ;
      END;
MAGLENGTH := I;
END;

procedure MagLinkInit(var TempBroker:TRPCBroker);
begin
{  Initialize the Link node for Imaging
   i.e. we set a ^TMP("MAGLINK",$J,IP ADDRESS-WINDOW HANDLE) node }
TempBroker.param[0].ptype := literal;
TempBroker.param[0].value := INTTOSTR(application.mainform.HANDLE);
TempBroker.remoteprocedure := 'MAGG LINK INIT';
TempBroker.call;
end;




procedure MagLinkSet(var TempBroker:TRPCBroker ;node :string);
begin
{  now send CPRS (or other app's link node }
{ CPRS sent as 2nd parameter when it opened imaging. it's Link Node
    i.e. ^TMP("CPRSLINK",$J,IP ADDRESS-WINDOW HANDLE)  }

TempBroker.param[0].ptype := literal;
TempBroker.param[0].value := node;
TempBroker.remoteprocedure := 'MAGG LINK SET';
TempBroker.call;
end;

procedure MagLinkGet(var TempBroker:TRPCBroker ;var dfn :string);
begin
TempBroker.remoteprocedure := 'MAGG LINK GET';
TempBroker.call;
DFN := TempBroker.results[0];
end;



Procedure MagLogoff(var TempBroker:TRPCBroker);
begin
IF NOT TempBroker.connected then exit;
TempBroker.remoteprocedure := 'MAGG LOGOFF';
TempBroker.call;
end;

procedure showimagelist(stmp : Tlistbox; lstControl :TlistBox) ;
var
   i,j : integer ;
   s,t : string ;
begin
i:=stmp.items.count-1 ;
lstcontrol.clear;
for j:=0 to i do
    begin
    s :=stmp.items[j];
    { our s is set up like :
         Desc Cat  ^  Object Type  ^  Doc Date  ^  short desc.}
    t := magpiece(s,'^',1) + '   ' + magpiece(s,'^',2) + '   '
         + magpiece(s,'^',3) + '   ' + magpiece(s,'^',4) ;
    lstcontrol.items.add(t)  ;
    end;
end;


FUNCTION magStrToInt(str: string) :longint ;
var done : boolean;
var s,t  :STRING;
x : integer ;
begin
done := false;
repeat
x := pos(' ',str);
if x>0 then
       begin
       s:=copy(str,1,X-1); T:=copy(str,x+1,length(str));
       str := s+t;
       end;
if x=0 then done := true    ;
until done;
magStrToInt := strtoint(str);
end;

FUNCTION magStripspaces(str: string) :string ;
var done : boolean;
var s  :STRING;
begin
IF STR='' THEN begin magstripspaces := ''; exit; end;   {fix for hang}
done := false;
repeat
s := str[1];
if (s = ' ') then str := copy(str,2,length(str));
if not (str[1] = ' ') then done := true;
if str='' then done := true;           {fix for hang}
until done  ;
done := false;
repeat
s := str[length(str)]; if (s = ' ') then str := copy(str,1,length(str)-1);
if not (str[length(str)] = ' ') then done := true;
if str='' then done := true;       {fix for hang}
until done   ;
magStripspaces := str;
end;

FUNCTION USERHAVEKEY(FORM:TFORM; DUZ,KEY :STRING):STRING;
BEGIN
{  put this code in your program.
RPCBroker1.PARAM[0].PTYPE := LITERAL ;
RPCBroker1.PARAM[0].VALUE := DUZ     ;
RPCBroker1.PARAM[1].PTYPE := LITERAL ;
RPCBroker1.PARAM[1].VALUE := KEY     ;
RPCBroker1.remoteprocedure := 'MAGGDUZKEY';
RPCBroker1.call;
USERHAVEKEY := RPCBroker1.Result;
}
END;


end.


