program MagVerifier;

   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Verifier
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)


uses
  Forms,
  magjbscan1 in 'magjbscan1.pas' {MagJBScan},
  JBScanResults in 'JBScanResults.pas' {magJBSResults},
  Telabout in 'telabout.pas' {TELABOUTF},
  MagShowLog in 'MagShowLog.pas' {ShowLog},
  magWebHelp in 'magWebHelp.pas' {frmMagBPHelp},
  MagOfflineWrn in 'MagOfflineWrn.pas' {frmMagOffline};

{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'BP Verifier';
  Application.CreateForm(TMagJBScan, MagJBScan);
  Application.Run;
end.
