unit fraMagImageInfo;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:  12/2003
   Site Name: Silver Spring, OIFO
   Developers: Garrett Kirin
   [==     unit fraMagImageInfo;
   Description: Image Information frame, used multiple times in the
        frmMagImageInfo window to display the Image information and Abstract.

        The frame has components TMag4Vgear which is used to display the abstract
        and a ScrollBox which is used to display the Image information.
        ==]
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons  , ExtCtrls, cMag4VGear
  {VA}
  {, cMag4VGear} { , cMagDBBroker }{,uMagClasses }{,cMagPat} {,GEARLib_TLB,}
  {,maggut4} {,geardef} ;

type
  TfraImageInfo = class(TFrame)
    Mag4Vgear1: TMag4Vgear;
    lbinfo: TLabel;
    btnClose: TBitBtn;
    Bevel1: TBevel;
    ScrollBox1: TScrollBox;
    lbImageInfo: TLabel;
    procedure btnCloseClick(Sender: TObject);
  private

    { Private declarations }
  public
      constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.DFM}

{ TfraImageInfo }

constructor TfraImageInfo.Create(AOwner: TComponent);
begin
  inherited;
name := '';
end;

procedure TfraImageInfo.btnCloseClick(Sender: TObject);
begin
visible := false;
end;

end.
