unit ucolumnlister;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, Buttons, ExtCtrls, ComCtrls,cmaglistview;

type
  Tcolumnlisterform = class(TForm)
    chlistColumns: TCheckListBox;
    Label1: TLabel;
    Panel1: TPanel;
    btnApply: TBitBtn;
    btnClose: TBitBtn;
    btnOK: TBitBtn;
    btnAll: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnAllClick(Sender: TObject);
  private
   FLV : TMaglistview;
   procedure SetVisibleColumns;
    { Private declarations }
  public
    procedure DisplayColumns(LV : TMagListView); //;colwidth: array of integer;colvisible : array of boolean);
  end;

var
  columnlisterform: Tcolumnlisterform;

implementation

{$R *.DFM}

procedure Tcolumnlisterform.FormCreate(Sender: TObject);
begin
  chlistColumns.Align := alclient;
end;

procedure Tcolumnlisterform.btnApplyClick(Sender: TObject);
begin
SetVisibleColumns;
//  modalresult := mrOK;

end;


procedure Tcolumnlisterform.SetVisibleColumns;
var i : integer;
begin
  FLV.visible := false;
  try
for i := 0 to chlistcolumns.items.count-1 do
begin

  if not chlistcolumns.checked[i] then
    begin
      FLV.Columns[i].Width := 0;
      FLV.FColVisible[i] := false;
    end
       else
       begin
       FLV.FColVisible[i] := true;
       if (FLV.columns[i].width = 0) then FLV.columns[i].width := FLV.FColWidth[i] + 10;
       end;
end;
finally
  FLV.visible := true;
  end;
end;

procedure Tcolumnlisterform.DisplayColumns(LV: TMaglistview); //;colwidth: array of integer;colvisible : array of boolean);
var I : integer;
begin
FLV := LV;
chlistcolumns.items.Clear;
for i := 0 to Flv.Columns.Count -1  do
    begin
     chlistcolumns.Items.Add(Flv.columns[I].Caption);
     chlistcolumns.Checked[i] := (Flv.columns[I].width > 0);
   // chlistcolumns.Checked[i] := (FLV.Fcolvisible[I]);
    end;
//chlistcolumns.ItemEnabled[0] := false;
end;

procedure Tcolumnlisterform.btnCloseClick(Sender: TObject);
begin
close;
end;

procedure Tcolumnlisterform.btnOKClick(Sender: TObject);
begin
SetVisibleColumns;
//  modalresult := mrOK;
end;

procedure Tcolumnlisterform.btnAllClick(Sender: TObject);
var I : integer;
begin
for i := 0 to chlistcolumns.items.Count -1  do
    begin

     chlistcolumns.Checked[i] := true;

    end;
SetVisibleColumns;
end;

end.
