unit BPHelp1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmHelp = class(TForm)
    lbHelp: TListBox;
    Panel1: TPanel;
    btnClose: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCloseClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnCloseMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmHelp: TfrmHelp;

implementation

{$R *.dfm}

procedure TfrmHelp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  frmHelp.ModalResult := mrCancel;
  Action := caFree;
end;

procedure TfrmHelp.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmHelp.FormActivate(Sender: TObject);
begin
  Application.NormalizeTopMosts;
  SetWindowPos(frmHelp.Handle, HWND_TOPMOST, 0,0,0,0,
     SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
 btnClose.SetFocus;
end;

procedure TfrmHelp.btnCloseMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 BtnCloseClick(sender);
end;

end.
