unit MagBPparam;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Trpcb, Diaccess,Fmcmpnts, ExtCtrls, Fmcntrls, Fmlookup, OleCtrls, { isp3,}
  MagSecurityUnit,MagBroker, maggut1,MagSec_C, ComCtrls, Buttons, FileCtrl,fmagDirectoryDialog;

type
  TfrmMagBPparam = class(TForm)
    FMFiler1: TFMFiler;
    GroupBox1: TGroupBox;
    FMCheckBox2: TFMCheckBox;
    FMCheckBox3: TFMCheckBox;
    FMCheckBox4: TFMCheckBox;
    FMCheckBox5: TFMCheckBox;
    lblBPWS: TLabel;
    FMListBox1: TFMListBox;
    FMHelp1: TFMHelp;
    Panel1: TPanel;
    FMCheckBox6: TFMCheckBox;
    FMCheckBox7: TFMCheckBox;
    FMCheckBox9: TFMCheckBox;
    FMValidator1: TFMValidator;
    bbtnOK: TBitBtn;
    bbtnCancel: TBitBtn;
    btnApply: TBitBtn;
    GroupBox2: TGroupBox;
    fmeNetLogArch: TFMEdit;
    BitBtn1: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure BPParamShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure filer1ud(Sender: TObject);
    procedure UpdateBoolean(sender: TObject;var Filer:TFMFiler);
    procedure EnableEditing;
    procedure DisableEditing;
//    procedure BPCheckBox(Sender: TObject);
    procedure clearCB;
    procedure btnApplyClick(Sender: TObject);
    procedure bbtnCancelClick(Sender: TObject);
    procedure bbtnOKClick(Sender: TObject);
    procedure CheckUpdate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMagBPparam: TfrmMagBPparam;

implementation

{$R *.DFM}
  uses {Magbtm1}, UnitDM;
procedure TfrmMagBPparam.BPParamShow(Sender: TObject);
var i: integer;
begin
  dmMain.fmgBPWS.IENS := FMListBox1.GetSelectedRecord.IEN;
  for i := 0 to GroupBox1.ControlCount - 1 do begin
    if (GroupBox1.Controls[i] is TFMCheckBox) then
      with GroupBox1.Controls[i] as TFMCheckBox do
        IENS := FMListBox1.GetSelectedRecord.IEN;
    end;
  fmeNetLogArch.IENS := FMListBox1.GetSelectedRecord.IEN;
  dmMain.fmgBPWS.GetAndFill;
  fmeNetLogArch.Hint := fmeNetLogArch.Text;
end;

procedure TfrmMagBPparam.CheckUpdate(Sender: TObject);
var i: integer;
begin
  if FMFiler1.AnythingToFile then
    if messagedlg('Do you wish to save changes?',mtConfirmation	, [mbYes, mbNo], 0) = mrYes
        then FMFiler1.Update
    else FMFiler1.Clear;
  dmMain.fmgBPWS.IENS := FMListBox1.GetSelectedRecord.IEN;
  for i := 0 to GroupBox1.ControlCount - 1 do begin
    if (GroupBox1.Controls[i] is TFMCheckBox) then
      with GroupBox1.Controls[i] as TFMCheckBox do
        IENS := FMListBox1.GetSelectedRecord.IEN;
    end;
  fmeNetLogArch.IENS := FMListBox1.GetSelectedRecord.IEN;
  dmMain.fmgBPWS.GetAndFill;
  fmeNetLogArch.Hint := fmeNetLogArch.Text;
end;


procedure TfrmMagBPparam.FormActivate(Sender: TObject);
begin
  application.ShowHint:=true;
  application.HintPause :=1000;
  application.HintHidePause := 8000;
  btnApply.Enabled := false;
  with frmMagBPparam do begin
    Caption := Caption + '   '+ Copy(MagBTM1.CompName,0,3);
    Update;
    end;
   with dmMain.fmlBPWS do begin
     Screen := 'I $P(^(0),U,2)='+ IntToStr(magbtm1.place);
     GetList(FMListBox1.Items);
     end;
  if FMListBox1.Items.Count <> 0 then begin
    FMListBox1.ItemIndex := 0;
    BPParamShow(Self);
    end
  else begin
    showmessage('There are no BP Workstations setup for this site');
    DisableEditing;
    end;
end;

procedure TfrmMagBPparam.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if FMFiler1.AnythingToFile then
  if messagedlg('Do you wish to save changes?',mtConfirmation	, [mbYes, mbNo], 0) = mrYes
        then FMFiler1.Update;
  magbtmf1.mnuBPWorkstationQueues1.Checked := false;
end;

procedure TfrmMagBPparam.filer1ud(Sender: TObject);
  begin
   with sender as TFMCheckBox do begin
     if FMModified then
       if Validate then begin
         FMFiler1.AddChgdControl(Sender);
         btnApply.Enabled := true;
         end
       else begin
         GetAndDisplayHelp;
         Checked := FMTag;
         end;
     end;
  end;
procedure TfrmMagBPparam.UpdateBoolean(sender: TObject; var Filer:TFMFiler);
begin
  with sender as TFMCheckBox do begin
    checked := false;
    FMCtrlInternal := FMValueUnchecked;
    Filer.AddChgdControl(sender);
     btnApply.Enabled := true;
    end;
end;


procedure TfrmMagBPparam.DisableEditing;
var i : integer;
begin
  for i := 0 to GroupBox1.ControlCount - 1 do begin
    if (GroupBox1.Controls[i] is TFMCheckBox) then
      with GroupBox1.Controls[i] as TFMCheckBox do
       Enabled := false;
    end;
end;
procedure TfrmMagBPparam.EnableEditing;
var i : integer;
begin
  for i := 1 to GroupBox1.ControlCount - 1 do begin
    if (GroupBox1.Controls[i] is TFMCheckBox) then
      with GroupBox1.Controls[i] as TFMCheckBox do
       Enabled := true;
    end;
end;
procedure TfrmMagBPparam.clearCB;
var i: integer;
begin
  for i := 1 to GroupBox1.ControlCount - 1 do begin
    if (GroupBox1.Controls[i] is TFMCheckBox) then
      with GroupBox1.Controls[i] as TFMCheckBox do begin
        FMCtrlInternal := FMValueUnchecked;
        FMFiler1.AddChgdControl(GroupBox1.Controls[i]);
        end;
    end;

end;

procedure TfrmMagBPparam.btnApplyClick(Sender: TObject);

begin
  if FMFiler1.AnythingToFile then FMFiler1.Update;
  btnApply.Enabled := false;
end;

procedure TfrmMagBPparam.bbtnCancelClick(Sender: TObject);
begin
 frmMagBPparam.Close;
end;

procedure TfrmMagBPparam.bbtnOKClick(Sender: TObject);
begin
 if FMFiler1.AnythingToFile then FMFiler1.Update;
 frmMagBPparam.Close;
end;

procedure TfrmMagBPparam.FormCreate(Sender: TObject);
begin
  dmMain.FMComponentInit(self);
  frmMagBPparam.caption := format('%s - %s',[' '+Magbtm1.SiteName,' BP WS Parameters ']);
end;

procedure TfrmMagBPparam.BitBtn1Click(Sender: TObject);
var vDir: String;
begin
vdir := fmeNetLogArch.Text;
if  frmDirectoryDialog.execute(vDir )
  then  //
//  showmessage(vDir);
  fmeNetLogArch.Text := Vdir;
  FMFiler1.AddChgdControl(fmeNetLogArch);
  btnApply.Enabled := true;
end;

end.
