unit MagPerResults;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Printers;

type
  TfrmPurgeResults = class(TForm)
    lbResults: TListBox;
    mnuMain: TMainMenu;
    mnuFile1: TMenuItem;
    mnuPrint1: TMenuItem;
    mnuExit: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    procedure mnuPrint1Click(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPurgeResults: TfrmPurgeResults;

implementation

{$R *.DFM}
uses magpurge1;

procedure TfrmPurgeResults.mnuPrint1Click(Sender: TObject);
var
  PageNum: string;
  i,Ctr,x,PHeight,LineSpace: integer;
begin
  PrinterSetUpDialog1.Execute;
  Printer.BeginDoc;
    PHeight := Printer.PageHeight;
    LineSpace := PHeight DIV 60;
    Ctr := 1;
    x := 1;
    PageNum := IntToStr(Printer.PageNumber);
    for i := 0 to lbResults.items.count - 1 do begin
      Printer.Canvas.TextOut(0,x,lbResults.Items[i]);
      x := x + LineSpace;
      ctr := ctr + 1;
      If ctr > 59 then begin
        Printer.NewPage;
        x := 0;
        Ctr := 0;
        PageNum := IntToStr(Printer.PageNumber);
        end; // ctr > 59
      end; // for i
  Printer.EndDoc;

end;

procedure TfrmPurgeResults.mnuExitClick(Sender: TObject);
begin
//  MagPurge.mnuPurgeResults.checked := false;
//  MagPurge.mnuPurgeResults.Enabled := false;
//  frmPurgeResults.Visible := false;

end;

procedure TfrmPurgeResults.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//  MagPurge.mnuPurgeResults.checked := false;
end;

end.
