unit frmGenericCalendar1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons,DateUtils, ExtCtrls;

type
  TfrmGenericCalendar = class(TForm)
    MCSchedVerDate: TMonthCalendar;
    Panel1: TPanel;
    bbtnCancel: TBitBtn;
    bbtnOK: TBitBtn;
    procedure MCSchedVerDateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bbtnOKClick(Sender: TObject);
    procedure bbtnCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmGenericCalendar: TfrmGenericCalendar;

implementation

{$R *.dfm}
uses MagSiteParameters, FmagTimeDialog;
procedure TfrmGenericCalendar.MCSchedVerDateClick(Sender: TObject);
begin
  MagSiteParameters.DateString := DateToStr(MCSchedVerDate.date);
  bbtnOK.SetFocus;
 end;

procedure TfrmGenericCalendar.FormCreate(Sender: TObject);
begin
(* SetWindowLong( Handle,
     GWL_STYLE,
     GetWindowLong( Handle, GWL_STYLE )
     and not WS_CAPTION ) ;
*)
//   ClientHeight := Height;
 
 MCSchedVerDate.Date := TODAY;
 MCSchedVerDate.MinDate := TODAY;

end;

{By the way, *never* set a date variable using StrToDate on a string
literal! That would make your code fail if the user uses a different
locale than you do on your development system. If you need to set a
date variable to a defined value use the EncodeDate function to get
that value.
}


procedure TfrmGenericCalendar.bbtnOKClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TfrmGenericCalendar.bbtnCancelClick(Sender: TObject);
begin
 MagSiteParameters.DateString := '';
 ModalResult := mrOK;
end;

procedure TfrmGenericCalendar.FormActivate(Sender: TObject);
begin
  Application.NormalizeTopMosts;
  SetWindowPos(frmGenericCalendar.Handle, HWND_TOPMOST, 0,0,0,0,
    SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
  bbtnOk.SetFocus;

end;

end.
