unit MagExeWait;
 interface
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;


  function WinExecAndWait32(FileName:String; Visibility : integer;var xProcessInfo: TprocessInformation):dword;
  function WinExecNoWait32(FileName:String; Visibility : integer;var xProcessInfo: TprocessInformation):dword;
  function GetExitCode(var xProcessInfo: TprocessInformation): dword;
  Function MagTerminateProcess(exitcode:integer;var xProcessInfo: TprocessInformation): boolean;
  Function IsProcessRunning(var xProcessInfo: TprocessInformation): boolean;


implementation
{ var
 xProcessInfo: TprocessInformation;}

function WinExecAndWait32(FileName:String; Visibility : integer;var xProcessInfo: TprocessInformation):dword;
var
  zAppName:array[0..512] of char;
  zCurDir:array[0..255] of char;
  WorkDir:String;
  StartupInfo:TStartupInfo;
begin
  StrPCopy(zAppName,FileName);
  GetDir(0,WorkDir);
  StrPCopy(zCurDir,WorkDir);
  FillChar(StartupInfo,Sizeof(StartupInfo),#0);
  StartupInfo.cb := Sizeof(StartupInfo);

  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := Visibility;
  if not CreateProcess(nil,
    zAppName,                      { pointer to command line string }
    nil,                           { pointer to process security attributes }
    nil,                           { pointer to thread security attributes }
    false,                         { handle inheritance flag }
    CREATE_NEW_CONSOLE or          { creation flags }
    NORMAL_PRIORITY_CLASS,
    nil,                           { pointer to new environment block }
    nil,                           { pointer to current directory name }
    StartupInfo,                   { pointer to STARTUPINFO }
    xProcessInfo) then Result := 0 { pointer to PROCESS_INF }

  else begin
    WaitforSingleObject(xProcessInfo.hProcess,INFINITE);
    GetExitCodeProcess(xProcessInfo.hProcess,Result);
  end;
end;

function WinExecNoWait32(FileName:String; Visibility : integer;var xProcessInfo: TprocessInformation):dword;
var
  zAppName:array[0..512] of char;
  zCurDir:array[0..255] of char;
  WorkDir:String;
  StartupInfo:TStartupInfo;
 { ProcessInfo:TProcessInformation;}
begin
  StrPCopy(zAppName,FileName);
  GetDir(0,WorkDir);
  StrPCopy(zCurDir,WorkDir);
  FillChar(StartupInfo,Sizeof(StartupInfo),#0);
  StartupInfo.cb := Sizeof(StartupInfo);

  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := Visibility;
  if not CreateProcess(nil,
    zAppName,                      { pointer to command line string }
    nil,                           { pointer to process security attributes }
    nil,                           { pointer to thread security attributes }
    false,                         { handle inheritance flag }
    CREATE_NEW_CONSOLE or          { creation flags }
    NORMAL_PRIORITY_CLASS,
    nil,                           { pointer to new environment block }
    nil,                           { pointer to current directory name }
    StartupInfo,                   { pointer to STARTUPINFO }
    xProcessInfo) then Result := 0 { pointer to PROCESS_INF }

  else begin
    WaitforSingleObject(xProcessInfo.hProcess,0);
    GetExitCodeProcess(xProcessInfo.hProcess,Result);
  end;
end;

Function GetExitCode(var xProcessInfo: TprocessInformation): dword;
begin
 GetExitCodeProcess(xProcessInfo.hProcess,Result);
end;
{ This code came from Lloyd's help file! }

Function MagTerminateProcess(exitcode:integer;var xProcessInfo: TprocessInformation): boolean;
begin
result := TerminateProcess(xprocessInfo.hprocess,exitcode);
end;

Function IsProcessRunning(var xProcessInfo: TprocessInformation): boolean;
var x : integer;
begin
result := true;
x := GetExitCode(xprocessinfo);
if  x <> 259 then result := false

end;
end.
